import java.text.*;
import graph.*;
public class SozialesNetzwerk {

  private Graph bspGraph;
  private List<Zentralitaet> werteListe;

  public SozialesNetzwerk() {
     bspGraph = new Graph();
     werteListe = new List<Zentralitaet>();
  }
  
  public void erzeugeBeispiel1() {
    bspGraph = new Graph();
    bspGraph.addVertex(new Vertex("A"));
    bspGraph.addVertex(new Vertex("B"));
    bspGraph.addVertex(new Vertex("C"));
    bspGraph.addVertex(new Vertex("D"));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("A"),bspGraph.getVertex("B"),1));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("A"),bspGraph.getVertex("C"),1));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("A"),bspGraph.getVertex("D"),1));
    bspGraph.addEdge(new Edge(bspGraph.getVertex("B"),bspGraph.getVertex("C"),1));
  }
  
  public String adListenToString() {
    String ausgabe = "Adjazenzlisten \n";
    List<Vertex> knotenliste = bspGraph.getVertices();
    knotenliste.toFirst();
    while (knotenliste.hasAccess()) {
      Vertex knoten = knotenliste.getContent();
      ausgabe = ausgabe + knoten.getID()+":\t";
      List<Vertex> nachbarliste = bspGraph.getNeighbours(knoten);
      nachbarliste.toFirst();
      while (nachbarliste.hasAccess()) {
        Vertex k = nachbarliste.getContent();
        ausgabe = ausgabe + k.getID() + " "+ bspGraph.getEdge(knoten,k).getWeight()+" ";
        nachbarliste.next();
      }
      ausgabe = ausgabe + "\n";
      knotenliste.next();
    }
    return ausgabe;
  }
  
  private double dichte(int pAnzKnoten, int pAnzKanten) {
    int n = pAnzKnoten;
    int m = pAnzKanten;
    return (2.0*m)/(n*(n-1));
  }
  
  public String dichteToString() {
    DecimalFormat f = new DecimalFormat("#0.00");
    String ausgabe = "Dichte berechnen \n";
    int n = anzahlKnoten();
    int m = anzahlKanten();
    ausgabe = ausgabe +"Anzahl der Knoten: " + n + "\n";
    ausgabe = ausgabe +"Anzahl der Kanten: " + m + "\n";
    double d = dichte(n,m) ;
    ausgabe = ausgabe + "Dichte: " + f.format(d) + "\n";
    return ausgabe;
  }
  
  public String zentralgradToString() {
    String ausgabe = "Zentralitaetsgrade berechnen \n";
    bestimmeZentralitaetsgrade();
    werteListe.toFirst();
    while (werteListe.hasAccess()) {
      Zentralitaet z = (Zentralitaet) werteListe.getContent();
      ausgabe = ausgabe + z.toString() + "\n";
      werteListe.next();
    }
    return ausgabe;
  }
  
  private int anzahlKanten() {
    int anz = 0;
    List<Edge>liste = bspGraph.getEdges();
    liste.toFirst();
    while (liste.hasAccess()) {
      anz = anz + 1;
      liste.next();
    }
    return anz;
  }
  
  private int anzahlKnoten() {
    int anz = 0;
    List<Vertex> liste = bspGraph.getVertices();
    liste.toFirst();
    while (liste.hasAccess()) {
      anz = anz + 1;
      liste.next();
    }
    return anz;
  }
  
  private int anzahlNachbarn(Vertex knoten) {
    int anzahl = 0;
    List<Vertex> nachbarliste = bspGraph.getNeighbours(knoten);
      nachbarliste.toFirst();
      while (nachbarliste.hasAccess()) {
        anzahl = anzahl + 1;
        nachbarliste.next();
      }
    return anzahl;
  }
  
  private void bestimmeZentralitaetsgrade() {
    List<Vertex> liste = bspGraph.getVertices();
    int n = anzahlKnoten();
    liste.toFirst();
    while (liste.hasAccess()) {
      Vertex knoten =  liste.getContent();
      double wert = 1.0*anzahlNachbarn(knoten)/(n-1);
      ergaenzeWerteliste(new Zentralitaet(knoten,wert));
      liste.next();
    }
  }
  
  private void ergaenzeWerteliste(Zentralitaet pZWert) {
    werteListe.append(pZWert);
  }
}
